library polymer_collapse;

//import "dart:async";
import "dart:html";
import "dart:async";
//import "package:polymer/polymer.dart";
import "package:unittest/unittest.dart";
//import "package:unittest/matcher.dart";
import "package:unittest/html_enhanced_config.dart";
//import "package:logging/logging.dart";
//import "package:logging_handlers/browser_logging_handlers.dart";
import "package:polymer_elements/polymer_collapse.dart";

/**
 * Sanitizer which does nothing.
 */
class NullTreeSanitizer implements NodeTreeSanitizer {
  void sanitizeTree(Node node) {}
}

void main() { 
  //return;
  useHtmlEnhancedConfiguration();

  test("polymer-collapse", () {
    Duration delay = new Duration(milliseconds: 300);
    var done = expectAsync0((){});
    Timer.run(() {
      var c = (document.querySelector('#collapse'));
      expect(c.closed, isFalse);
      new Future.delayed(delay, () {
        var origH = getBoxComputedHeight();
        expect(origH, isNot(equals(0)));
        c.closed = true;
        new Future.delayed(delay, () {
          // after closed, height is 0
          expect(getBoxComputedHeight(), equals(0));
          // should be set to display: none
          expect(getBoxComputedStyle().display, equals('none'));
          c.closed = false;
          new Future.delayed(delay, () {
            // verify computed height
            expect(getBoxComputedHeight(), equals(origH));
            // after opened, height is set to 'auto'
            expect(document.querySelector('#box').style.height, equals('auto'));
            done();
          });
        });
      });
    });
  });
}

  
dynamic getBoxComputedStyle() {
  HtmlElement b = document.querySelector('#box');
  return b.getComputedStyle();
}

int getBoxComputedHeight() {
  String h = getBoxComputedStyle().height;
  String digits = new RegExp(r"^(\d+).*$").firstMatch(h).group(1);
  return int.parse(digits);
}
